-----------------------------------------------------------------------
--
--   Beispielskript zum Vortrag "Access und SQL Server-Verschlsselung"
--
--   Autor: Bernd Jungbluth										
--   Keine Gewhrleistung, keine Haftung
--
-----------------------------------------------------------------------

USE semKrypto;
GO


----------------------------------------------------------------
-- Zertifikat mit Kennwortschutz anlegen und sichern
----------------------------------------------------------------

CREATE CERTIFICATE certMitarbeiterBewertung
	ENCRYPTION BY PASSWORD = 'VerbesserungswrdigesKennwort'
	WITH SUBJECT = 'Zertifikat zum Testen',
	EXPIRY_DATE = '20301231';
GO

--> Nur ein Datensatz in einer Tabelle
SELECT * FROM sys.certificates;
GO

-- Zertifikat sichern
BACKUP CERTIFICATE certMitarbeiterBewertung 
	TO FILE = 'D:\Vortrge\Access und SQL Server-Verschlsselung\Tresor\certMitarbeiterBewertung.cer';
GO

-- Zertifikat mit privatem Schlssel in eigener Datei sichern
BACKUP CERTIFICATE certMitarbeiterBewertung 
	TO FILE = 'D:\Vortrge\Access und SQL Server-Verschlsselung\Tresor\certMitarbeiterBewertungPvk.cer'
	WITH PRIVATE KEY 
			(DECRYPTION BY PASSWORD = 'VerbesserungswrdigesKennwort',
			FILE = 'D:\Vortrge\Access und SQL Server-Verschlsselung\Tresor\certMitarbeiterBewertungPvk.pvk',
			ENCRYPTION BY PASSWORD = 'Dasistimmernochverbesserungswrdig');
GO


----------------------------------------------------------------
-- Symmetrischen Schlssel anlegen
----------------------------------------------------------------

CREATE SYMMETRIC KEY skeyMitarbeiterBewertung
	WITH ALGORITHM = AES_256
	ENCRYPTION BY CERTIFICATE certMitarbeiterBewertung;
GO

--> Nur ein Datensatz in einer Tabelle
SELECT * FROM sys.symmetric_keys;
GO

