-----------------------------------------------------------------------
--
--   Beispielskript zum Vortrag "Access und SQL Server-Verschlsselung"
--
--   Autor: Bernd Jungbluth										
--   Keine Gewhrleistung, keine Haftung
--
-----------------------------------------------------------------------

USE semKrypto;
GO


----------------------------------------------------------------
-- Daten anzeigen
----------------------------------------------------------------

SELECT MitarbeiterID, Nachname, Bewertung, crptBewertung FROM dbo.Mitarbeiter;


----------------------------------------------------------------
-- Per Symetrischem Schlssel verschlsseln
----------------------------------------------------------------

-- Symmetrischen Schlssel fr diese Session ffnen
OPEN SYMMETRIC KEY skeyMitarbeiterBewertung 
	DECRYPTION BY CERTIFICATE certMitarbeiterBewertung
		WITH PASSWORD = 'VerbesserungswrdigesKennwort';

-- Daten der Spalte Bewertung verschlsseln und in Spalte crptBewertung speichern
UPDATE	dbo.Mitarbeiter
SET		crptBewertung = ENCRYPTBYKEY(KEY_GUID('skeyMitarbeiterBewertung'), Bewertung);

-- Daten zeigen
SELECT MitarbeiterID, Nachname, Bewertung, crptBewertung FROM dbo.Mitarbeiter; 

-- Daten entschlsseln
SELECT	MitarbeiterID, Nachname, Bewertung, crptBewertung As crptBewertungOriginal,
		CAST(DECRYPTBYKEY(crptBewertung) AS CHAR(1)) As crptBewertung
FROM	dbo.Mitarbeiter;

-- Nach Spalte crptBewertung filtern
SELECT	MitarbeiterID, Nachname, Bewertung, crptBewertung As crptBewertungOriginal, 
		CAST(DECRYPTBYKEY(crptBewertung) AS CHAR(1)) As crptBewertung
FROM	dbo.Mitarbeiter
WHERE	CAST(DECRYPTBYKEY(crptBewertung) AS CHAR(1)) = 'C';

-- Symmetrischen Schlssel explizit schlieen
CLOSE SYMMETRIC KEY skeyMitarbeiterBewertung;
GO


----------------------------------------------------------------
-- Alternative Methode zum Entschlsseln
-- Kombination aus OPEN SYMMETRIC KEY und DECRYPTBYKY
----------------------------------------------------------------
SELECT	MitarbeiterID, Nachname, Bewertung, 
		CAST(
			 DECRYPTBYKEYAUTOCERT(CERT_ID('certMitarbeiterBewertung'), 
								  N'VerbesserungswrdigesKennwort', 
								  crptBewertung) 
		AS NVARCHAR(50)) As crptBewertung
FROM	dbo.Mitarbeiter;
GO