-----------------------------------------------------------------------
--
--   Beispielskript zum Vortrag "Access und SQL Server-Verschlsselung"
--
--   Autor: Bernd Jungbluth										
--   Keine Gewhrleistung, keine Haftung
--
-----------------------------------------------------------------------

USE semKrypto;
GO


----------------------------------------------------------------
-- Gespeicherte Prozedur zum Entschlsseln von Daten
----------------------------------------------------------------

CREATE PROC dbo.pSelectMitarbeiterBewertung 
AS
SET NOCOUNT ON;
	
	-- Symmetrischen Schlssel ffnen
	OPEN SYMMETRIC KEY skeyMitarbeiterBewertung 
		DECRYPTION BY CERTIFICATE certMitarbeiterBewertung
			WITH PASSWORD = 'VerbesserungswrdigesKennwort';

	-- Daten ausgeben und Wert entschlsseln
	SELECT	MitarbeiterID, Nachname, Bewertung, 
			CAST(DECRYPTBYKEY(crptBewertung) AS NVARCHAR(50)) As crptBewertung
	FROM	dbo.Mitarbeiter;

	-- Symmetrischen Schlssel explizit schlieen
	CLOSE SYMMETRIC KEY skeyMitarbeiterBewertung;
GO

----------------------------------------------------------------
-- Rechte fr Gespeicherte Prozedur vergeben
----------------------------------------------------------------

GRANT EXECUTE ON dbo.pSelectMitarbeiterBewertung TO Hesselbach;
GO