-----------------------------------------------------------------------
--
--   Beispielskript zum Vortrag "Access und SQL Server-Verschlsselung"
--
--   Autor: Bernd Jungbluth										
--   Keine Gewhrleistung, keine Haftung
--
-----------------------------------------------------------------------

USE semKrypto;
GO


----------------------------------------------------------------
-- Alternative Berechtigungsvergabe
----------------------------------------------------------------


-- Hesselbach Rechte entziehen
REVOKE VIEW DEFINITION ON SYMMETRIC KEY::skeyMitarbeiterBewertung TO Hesselbach;
REVOKE CONTROL ON CERTIFICATE::certMitarbeiterBewertung TO Hesselbach;
GO


-- Neuen Datenbankbenutzer anlegen
CREATE USER Hausmeister WITHOUT LOGIN;
GO


-- Hausmeister Rechte erteilen
GRANT VIEW DEFINITION ON SYMMETRIC KEY::skeyMitarbeiterBewertung TO Hausmeister;
GRANT CONTROL ON CERTIFICATE::certMitarbeiterBewertung TO Hausmeister;
GO


-- Absichern mit Gespeicherter Prozedur
CREATE PROC dbo.pOeffneSchluesselBewertung 
WITH
	EXECUTE AS 'Hausmeister'
AS
	OPEN SYMMETRIC KEY skeyMitarbeiterBewertung
		DECRYPTION BY CERTIFICATE certMitarbeiterBewertung
			WITH PASSWORD = 'Dasistauchnichtbesser!';
GO
-- Rechte an Gespeicherter Prozedur vergeben
GRANT EXECUTE ON dbo.pOeffneSchluesselBewertung TO Hesselbach;
GO


----------------------------------------------------------------------
-- Anpassen der Gespeicherten Prozedur dbo.pSelectMitarbeiterBewertung
----------------------------------------------------------------------

ALTER PROC dbo.pSelectMitarbeiterBewertung 
AS
SET NOCOUNT ON;

	-- Vorherige Variante
	-- OPEN SYMMETRIC KEY skeyMitarbeiterBewertung 
	--	DECRYPTION BY CERTIFICATE certMitarbeiterBewertung
	--		WITH PASSWORD = 'VerbesserungswrdigesKennwort';

	-- Schlssel mit Rechten von Hausmeister ffnen
	EXEC dbo.pOeffneSchluesselBewertung;

	-- Daten entschlsseln
	SELECT	MitarbeiterID, Nachname, Bewertung, 
			CAST(DECRYPTBYKEY(crptBewertung) AS CHAR(1)) As crptBewertung
	FROM	dbo.Mitarbeiter;

	-- Symmetrischen Schlssel explizit schlieen
	CLOSE SYMMETRIC KEY skeyMitarbeiterBewertung;
GO




----------------------------------------------------------
-- Verschlsseln des Quellcodes der Gespeicherten Prozedur
----------------------------------------------------------

ALTER PROC dbo.pOeffneSchluesselBewertung 
WITH
	EXECUTE AS 'HAusmeister',
	ENCRYPTION --> verschlsselt Quellcode
AS
	OPEN SYMMETRIC KEY skeyMitarbeiter 
		DECRYPTION BY CERTIFICATE certMitarbeiter
			WITH PASSWORD = 'Dasistauchnichtbesser!';
GO



