-----------------------------------------------------------------------
--
--   Beispielskript zum Vortrag "Access und SQL Server-Verschlsselung"
--
--   Autor: Bernd Jungbluth										
--   Keine Gewhrleistung, keine Haftung
--
-----------------------------------------------------------------------

USE master;
GO


----------------------------------------------------------------
-- Zertifikat fr Backup anlegen und sichern
----------------------------------------------------------------

-- Zertifikat anlegen
CREATE CERTIFICATE certBackup_semKrypto 
	WITH SUBJECT = 'Zertifikat zum Verschlsseln der Datenbanksicherung der Datenbank semKrypto',
	EXPIRY_DATE = '20301231';
GO  

-- Zertifikat inklusive privatem Schlssel sichern 
BACKUP CERTIFICATE certBackup_semKrypto 
	TO FILE = 'D:\Vortrge\Access und SQL Server-Verschlsselung\Tresor\certBackup_semKrypto.cer'
	WITH PRIVATE KEY 
		 (ENCRYPTION BY PASSWORD = 'DerprivateSchlsselvomZertifikat!',
		  FILE = 'D:\Vortrge\Access und SQL Server-Verschlsselung\Tresor\certBackup_semKrypto.pvk');
GO

-- Sichern der Datenbank semKrypto per Dialog



----------------------------------------------------------
-- Verschlsselte Datenbank wiederherstellen
----------------------------------------------------------

USE master;
GO

-- Zertifikat und Datenbank lschen
-- Wiederherstellen der Datenbank


-- Zertifikat importieren
CREATE CERTIFICATE certBackup_semKrypto   
    FROM FILE = 'D:\Vortrge\Access und SQL Server-Verschlsselung\Tresor\certBackup_semKrypto.cer'   
    WITH PRIVATE KEY (FILE = 'D:\Vortrge\Access und SQL Server-Verschlsselung\Tresor\certBackup_semKrypto.pvk',   
    DECRYPTION BY PASSWORD = 'DerprivateSchlsselvomZertifikat!');  
GO  

-- Wiederherstellen der Datenbank
