-----------------------------------------------------------------------
--
--   Beispielskript zum Vortrag "Access und SQL Server-Verschlsselung"
--
--   Autor: Bernd Jungbluth										
--   Keine Gewhrleistung, keine Haftung
--
-----------------------------------------------------------------------

USE semKrypto;
GO


-- Aktueller Benutzer
SELECT SUSER_SNAME() As AktuellerBenutzer;


----------------------------------------------------------------
-- Daten anlegen mit Always Encrypted
----------------------------------------------------------------

-- Daten anlegen
INSERT INTO dbo.Bewerber (StellenID, Nachname, Vorname, Strasse, Hausnummer, PLZ, Ort, Email, Gehaltswunsch, Religion)
VALUES (1, 'Feder', 'Stefanie', 'Gasse', '17a', '77777', 'Ortshausen', 'Feder.Stefanie@mail.de', 850, 'keltisch');
GO
--> Fehler


-- Notwendige Parametrisierung
DECLARE @StellenID	INT				= 1,
		@Nachname	NVARCHAR(20)	= 'Feder',
		@Vorname	NVARCHAR(10)	= 'Stefanie',
		@Strasse	NVARCHAR(25)	= 'Gasse',
		@Hausnr		NVARCHAR(25)	= '17a',
		@PLZ		NVARCHAR(10)	= '77777',
		@Ort		NVARCHAR(50)	= 'Ortshausen',
		@Email		NVARCHAR(255)	= 'Feder.Stefanie@mail.de',
		@Gehalt		MONEY			= 850,
		@Religion	NVARCHAR(50)	= 'keltisch';

INSERT INTO dbo.Bewerber (StellenID, Nachname, Vorname, Strasse, Hausnummer, PLZ, Ort, Email, Gehaltswunsch, Religion)
VALUES (@StellenID, @Nachname, @Vorname, @Strasse, @Hausnr, @PLZ, @Ort, @Email, @Gehalt, @Religion);
SELECT SCOPE_IDENTITY() As NeueID;
GO 
--> Funktioniert


----------------------------------------------------------------
-- Daten ndern mit Always Encrypted
----------------------------------------------------------------

-- Daten ndern
UPDATE dbo.Bewerber SET Religion = 'vulkanisch' WHERE BewerberID = 3;
GO
--> Fehler


-- Notwendige Parametrisierung 
DECLARE @Religion NVARCHAR(50) = N'vulkanisch';
UPDATE dbo.Bewerber SET Religion = @Religion WHERE BewerberID = 3;
GO


----------------------------------------------------------------
-- Daten lschen mit Always Encrypted
----------------------------------------------------------------

-- Notwendige Parametrisierung 
DECLARE @Religion NVARCHAR(50)	= 'vulkanisch';
DELETE FROM dbo.Bewerber WHERE Religion = @Religion;
GO